﻿Type=StaticCode
Version=2.2
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private frm As Form
	Private cMod As Object, cFun As String
	Public txtAddName As TextField
	Public txtAddPlatform As TextField
	Private btnPaste As Button
	Private btnCancel As Button
	Public cboAddPlat As ComboBox
	Public txtCode As TextArea
	Private btnAdd As Button
	Public lstSnip As List
	Public lstPlat As List
	Public imgNo As ImageView
	Public imgYes As ImageView
	Public jm As JMsgBox
	Public sqltext As String
	Public oName As String
End Sub
Public Sub loadform(callback_module As Object,callback_function As String) 
	lstSnip.Initialize
	lstPlat.Initialize
	
	cMod = callback_module
	cFun = callback_function
	
	frm.Initialize("frm",600,400)
	frm.RootPane.LoadLayout("addEdit")
	'frm.Title = "Secondary Form"
	frm.Show 
	jm.Initialize(frm)
	If Main.intEdAdd = 0 Then
	'set for add
	btnAdd.Text = "Add New Snip"
	Else
	'set for edit
	btnAdd.Text = "Update Snip"

	End If
	'**************************************************************
	'load platform combo
	Main.gCur = Main.gSQL.ExecQuery("SELECT DISTINCT platform FROM myCode")
		If Main.gCur.NextRow = False Then
			Log("none")
			Return 
		End If
		
	cboAddPlat.Items.clear
	cboAddPlat.Items.add(Main.gCur.Getstring("platform"))

	'Main.intPlatNum = Main.intPlatNum + 1

	Do While(Main.gCur.NextRow)
		cboAddPlat.items.add(Main.gCur.Getstring("platform"))
		'Main.intPlatNum = Main.intPlatNum + 1
	Loop

	Main.gCur.Close
	'**************************************************************
	
	imgNo.top = imgYes.top
	
	
	
	
	
	
	'**************************************************************
	'load lists for dupliacte checks
	Main.gCur = Main.gSQL.ExecQuery("SELECT * FROM myCode")

		If Main.gCur.NextRow = False Then
			Log("none")
			Return 
		End If
	

	lstSnip.add(Main.gCur.Getstring("snip").ToLowerCase)
	lstPlat.add(Main.gCur.Getstring("platform").ToLowerCase)

		Do While(Main.gCur.NextRow)
			lstSnip.add(Main.gCur.Getstring("snip").ToLowerCase)
			lstPlat.add(Main.gCur.Getstring("platform").ToLowerCase)
		Loop

	Main.gCur.Close
	'**************************************************************
End Sub
Sub btnCancel_MouseClicked (EventData As MouseEvent)
	'add/edit cancel input
	frm.Close
	CallSub(cMod,cFun)
End Sub
Sub btnAdd_MouseClicked (EventData As MouseEvent)
	'add/edit add new snip
	
	If Main.intEdAdd = 0 Then 
	'set for add
		If errorCodes = 0 Then
			addIt
		End If
	Else
	'set for edit
		updateIt(oName)
	End If
	
End Sub
Sub cboAddPlat_ValueChanged (Value As Object)
	'put platform combo value in platform text
	txtAddPlatform.Text = Value
End Sub

Sub btnPaste_MouseClicked (EventData As MouseEvent)
	'add/edit paste code
	'paste from clipboard
	Dim cs As String = fx.Clipboard.GetString
	txtCode.Text = cs
End Sub
Sub txtAddPlatform_TextChanged (Old As String, New As String)
	'check for duplicate platform name exists
	For i = 0 To lstPlat.Size - 1
		If txtAddPlatform.Text.ToLowerCase = lstPlat.Get(i) Then
	
		End If
	Next
End Sub
Sub txtAddName_TextChanged (Old As String, new As String)
	'check for duplicate snip name exists
	
	If Main.intEdAdd = 0 Then
	
		For i = 0 To lstSnip.Size - 1
		
			If txtAddName.Text.ToLowerCase = lstSnip.Get(i) Then
			imgYes.Visible = False
			imgNo.Visible = True
			Return
		
		Else
	
			imgYes.Visible = True
			imgNo.Visible = False
		End If
		Next
		
	End If
	
End Sub
Sub addIt
	'add new snip code
	'******************************
	'handle single quotes in text
	Dim wasT, isT As String
    wasT = txtCode.text
    isT = wasT.Replace("'","''")
	'***********************************




Dim field1, field2, field3 As String
	field1 = "snip"
	field2 = "platform"
	field3 = "code"


	sqltext = "INSERT INTO myCode ("
	sqltext = sqltext & field1 & ","
	sqltext = sqltext & field2 & ","
	sqltext = sqltext & field3 & ") VALUES ("
	sqltext = sqltext & "'" & txtAddName.text & "',"
	sqltext = sqltext & "'" & txtAddPlatform.text & "',"
	sqltext = sqltext & "'" &isT & "')"  
	If imgYes.visible = True Then
  	Main.gSQL.ExecNonQuery(sqltext)
	Else
	
	End If
	frm.Close
	CallSub(cMod,cFun)
End Sub
Sub updateIt(oldname As String)
	'update snip code
	'******************************
	'handle single quotes in text
	Dim wasTu, isTu As String
    wasTu = txtCode.text
    isTu = wasTu.Replace("'","''")' deal with single quotes
	'***********************************

	sqltext = "UPDATE myCode SET snip = '" & txtAddName.text & "',"
	sqltext = sqltext & " platform = '" & txtAddPlatform.Text & "',"
	sqltext = sqltext & " code = '" & isTu & "'"
	sqltext = sqltext & " WHERE snip = '" & oldname & "'"
	
	Main.gSQL.BeginTransaction
	Main.gSQL.ExecNonQuery(sqltext)
	Main.gSQL.TransactionSuccessful 
	
	frm.Close
	CallSub(cMod,cFun)

End Sub
Sub errorCodes As Int
	Dim er As Int
	If txtAddName.Text = "" Then
		jm.MsgBox("No Name Entered", "Info Missing")
		er = 1
		Return er
	End If
	If imgNo.Visible = True Then
		er = 1
		jm.MsgBox("Snip Alredy Exists", "Info Error")
		Return er

	End If
	If txtAddPlatform.Text = "" Then
		jm.MsgBox("No Platform Entered", "Info Missing")
		er = 1
		Return er
	End If
	If txtCode.Text = "" Then
		jm.MsgBox("No Code Entered", "Info Missing")
		er = 1
		Return er
	End If
'	If imgNo.Visible = False Then
'		jm.MsgBox("No Code Entered", "Info Missing")
'		er = 1
'		Return er
'	End If


	Return er
End Sub


